#include "punchsewmachine.h"
// 冲缝机      lxs 20220614 建立这个机型界面,当前是双头冲缝一体机,所以包括在内的机型都可以从这个改(单头冲缝一体机,双头冲孔机都可以从这儿改)[单头冲孔可以从冲孔界面应用]
PunchSewMachine::PunchSewMachine()
{
    //添加各种参数到列表中
    initRootParasList();
    initRootHMIConfigurationList(m_allParasList);//超级用户界面配置
    initRootIOTConfigurationList(m_allParasList); //超级用户物联网配置
    initPatternsParasList();
    initSoftwareParasList(m_allParasList);
    initTimeParasList(m_allParasList);
    initPunchSewCommonFunParasList(m_allParasList);
    initMcParasList();
    initWkParasList();

    //初始化控制动作列表
    initOutCtrlList();

    //初始化快捷功能列表
    initShortCutList();

    //初始化辅助功能列表
    initAssistList();

    //初始化花样设置功能列表
    initPatternSetList();

    //参数分类功能
    initParaSetList();

    //初始化传感器列表
    initSensorList();

    //初始化错误代码和状态列表
    initErrorCodeAndStateList();
}

PunchSewMachine::~PunchSewMachine()
{

}

//超级用户参数(包括机器参数、工作参数)
void PunchSewMachine::initRootParasList()
{
    //超级用户参数---------------------------
    //超级用户参数-界面配置；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_HMICONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("HMI Configuration"),//界面配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0000 , factory));

    //超级用户参数-界面进入调试模式；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DEBUGMODE, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Interface debug mode"),//界面进入调试模式
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , root));

    //超级用户参数-删除config.ini配置文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETEINI, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete configure file"),//删除配置文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 ,  root));

    //超级用户参数-重置花样配置-删除花样fcg文件影响fileid的数据;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_CLEARPATTERNFCG_FILEID, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete pattern configuration"),//删除花样配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001, factory));

    //超级用户参数-导入csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_IMPORTCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Import CSV file"),//导入csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-删除csv文件；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_DELETECSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Delete CSV file"),//删除csv文件
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-重置安装调试进度；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_RESETCSV, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Reset CSV file"),//重置安装调试进度
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0001 , factory));

    //超级用户参数-机器参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_MACHINEPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Machine parameters"),//机器参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0002, factory));

    //超级用户参数-工作参数；单位：无
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_WORKPARA, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Work parameters"),//工作参数
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x0003, factory));

    //超级用户参数-跳针生效;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_SKIPEFFECT, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("Jump stitch takes effect"),//跳针生效
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x000D, factory));

    //超级用户参数-物联网配置;
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_ROOT,
                                        0 ,
                                        ROOT_IOTCONFIGURATION, 0, 0, PARA_VALUE_TYPE_CLICK,
                                        tr("InternetofThings  configuration"),//物联网配置
                                        0, 0, 0, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x000D, factory));
}

//花样参数
void PunchSewMachine::initPatternsParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    //花样参数-花样设置参数-翻转式样；单位：无 ，范围0-7，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATESTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Flip style"),//翻转式样
                                        0, 0, 7, 0, 0, tr(""), tr(""),
                                        tr("normalP:0;nRight90P:1;nRight180P:2;nRight270P:3;mirrorP:4;mRight90P:5;mRight180P:6;mRight270P:7"),
                                        0, 0, 0x0001, operate));

    //花样参数-花样设置参数-水平翻转样式；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_HORIZONTALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Horizontal flip style"),//水平翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0002, operate));

    //花样参数-花样设置参数-垂直翻转式样；单位：无 ，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_VERTICALSTYLE, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("vertical flip style"),//垂直翻转式样
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Yes:1"),
                                        0, 0, 0x0002, operate));

    //花样参数-花样设置参数-旋转角度；单位：° ，范围0-90，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_ROTATEANGLE, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Rotation angle"),//旋转角度
                                        0, 0, 90, 0, 0, cod->toUnicode("°"), tr(""),//度
                                        tr(""), 0, 0,0x0003, operate));

    //花样参数-花样设置参数-连续动框补偿；单位：无，范围0-1000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_CONTINURUNCOMP, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Continuous motion frame compensation"),//连续动框补偿
                                        0, 0, 1000, 0, 0, tr(""), tr(""),//
                                        tr(""), 0, 0,0x0004, operate));

    //花样参数-花样设置参数-针尖补偿；单位：mm，范围-200-200，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_NEEDLETIPCOMP, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Needle tip compensation"),//针尖补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),//
                                        tr(""), 0, 0,0x0005, operate));

    //花样参数-花样设置参数-需要分割的针步长度；单位：mm，范围3-20，默认7
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_PATTERN,
                                        0 ,
                                        SET_SPLITSTITCHLENGTH, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of the stitch that needs to be split"),//需要分割的针步长度
                                        700, 300, 2000, 700, 2, tr("mm"), tr(""),//mm
                                        tr(""), 0, 0,0x0006, operate));

    //花样参数---------------------------
}

//机器参数
void PunchSewMachine::initMcParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    // 冲孔机头个数，无单位， 范围1-32，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        2, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of punching heads"),// 冲孔机头个数
                                        1, 1, 32, 1, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0000, operate));

    // 冲孔每头冲针个数，无单位， 范围1-16，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        3, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of needles per head for punching"),
                                        1, 1, 16, 1, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0001, operate));

    // X轴配置，无单位， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis configuration"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x0002, operate));

    // X轴电机驱动选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis motor drive selection"),
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Single motor:0;Double motor:1"),//单驱动:0;双驱动:1
                                        0, 0, 0x0003, operate));

    // X轴坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis coordinate system selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Positive:0;Reverse:1"),//正:0;反:1
                                        0, 0, 0x0004, operate));

    // X轴移动对象选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis moving object selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Head:0;Frame:1"),//机头:0;框:1
                                        0, 0, 0x0005, operate));

    // X轴零位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis zero sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x0006, operate));

    // X轴降速传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis speed reduction sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x0007, operate));

    // X轴正限位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis positive limit sensor selection"),
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x0008, factory));

    // X轴负限位传感器选择， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis negative limit sensor selection"),//X轴负限位传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0009, operate));

    // X轴零位方向选择， 范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis zero direction selection"),//X轴零位方向选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Negative:0;Positive:1"),//负方向:0;正方向:1
                                        0, 0, 0x0010, operate));

    // X轴传感器作用选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        10, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("X axis sensor function selection"),//X轴传感器作用选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Zero separate:0;Zero and speed reduction:1"),//零分离:0;零点和减速:1
                                        1, 1, 0x0011, operate));

    // Y轴配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis configuration"),//Y轴配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0012, operate));

    // Y轴电机驱动选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis motor drive selection"),//Y轴电机驱动选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Single motor:0;Double motor:1"),//单驱动:0;双驱动:1
                                        0, 0, 0x0013, operate));

    // Y轴坐标系统选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis coordinate system selection"),//Y轴坐标系统选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Positive:0;Reverse:1"),//正:0;反:1
                                        1, 1, 0x0014, operate));

    // Y轴移动对象选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis moving object selection"),//Y轴移动对象选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Head:0;Frame:1"),//机头:0;框:1
                                        1, 1, 0x0015, operate));

    // Y轴零位传感器选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis zero sensor selection"),//Y轴零位传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0016, operate));

    // Y轴降速传感器选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis speed reduction sensor selection"),//Y轴降速传感器选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0017, operate));

    // Y轴正限位传感器， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis positive limit sensor selection"),//Y轴正限位传感器
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0020, operate));

    // Y轴负限位传感器， 范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis negative limit sensor selection"),//Y轴负限位传感器
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0021, operate));

    //Y轴零位方向选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis zero direction selection"),//Y轴零位方向选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Negative:0;Positive:1"),//负方向:0;正方向:1
                                        0, 0, 0x0022, operate));

    //Y轴传感器作用选择，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        11, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Y axis sensor function selection"),//Y轴传感器作用选择
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Zero separate:0;Zero and speed reduction:1"),//零分离:0;零点和减速:1
                                        1, 1, 0x0023, operate));

    //缝纫主轴配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        14, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing spindle configuration"),//缝纫主轴配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        1, 1, 0x0038, operate));

    //针梭配置，范围0-1，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        14, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle shuttle configuration"),//针梭配置
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Needle shuttle:0;Needle shuttle separation:1"),//针穿梭:0;针梭分离:1
                                        1, 1, 0x0039, operate));

    //升降电机配置，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        15, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Lift motor configuration"),//升降电机配置
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No:0;Have:1"),//无:0;有:1
                                        0, 0, 0x003A, operate));

    //下剪刀驱动装置选择，范围0-4，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        18, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Lower scissors drive selection"),//下剪刀驱动装置选择
                                        1, 0, 4, 1, 0, tr(""), tr(""),
                                        tr("No lower trimming device:0;Cylinder:1;AC motor:2;Stepper motor:3;Electromagnet:4"),//无下剪线装置:0;气缸:1;交流电机:2;步进电机:3;电磁铁:4
                                        1, 1, 0x0041, operate));

    //下剪线模式选择，范围0-3，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        19, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Lower trimming mode selection"),//下剪线模式选择
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Static trimming:0;Dynamic trimming:1;Cam trimming:2;Cam respectively trimming:3"),//静态剪线:0;动态剪线:1;凸轮剪线:2;凸轮分别剪线:3
                                        0, 0, 0x0042, operate));

    //上剪刀驱动装置选择， 范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        20, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Upper scissors drive selection"),//上剪刀驱动装置选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("No Upper trimming Device:0;Cylinder:1"),//无上剪线装置:0;气缸:1
                                        0, 0, 0x0043, operate));

    //面线断线检测装置选择，范围0-2，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        21, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Upper thread break detection device selection"),//面线断线检测装置选择
                                        1, 0, 2, 1, 0, tr(""), tr(""),
                                        tr("No:0;Pick wire spring:1;Electronic isolation:2"),//无:0;拣选钢丝弹簧:1;电子隔离开关:2
                                        1, 1, 0x0044, operate));

    //断线检测模式选择，范围0-1，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        23, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Wire break detection mode selection"),//断线检测模式选择
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Direct detection:0;EXBboard detection:1"),//直接检测:0;外围板检测:1
                                        0, 0, 0x0046, operate));

    //勾面线装置选择，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        24, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Hook line device selection"),//勾面线装置选择
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No hook line device:0;Cylinder:1;Electromagnet:2"),//无勾线装置:0;气缸:1;电磁铁:2
                                        0, 0, 0x0047, operate));

    //松面线装置选择，范围0-2，默认1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        25, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Loose line device selection"),//松面线装置选择
                                        1, 0, 2, 1, 0, tr(""), tr(""),
                                        tr("No loose wire device:0;Cylinder:1;Electromagnet:2"),//无松线装置:0;气缸:1个;电磁铁:2
                                        1, 1, 0x0048, operate));

    //拉面线装置选择，范围0-2，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        26, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Ramen line device selection"),//拉面线装置选择
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("No ramen line device:0;Cylinder:1;Electromagnet:2"),//无拉面线装置:0;气缸:1;电磁铁:2
                                        0, 0, 0x0049, operate));

    //扣底线装置选择，范围0-2，默认2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        27, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Bottom line device selection"),//扣底线装置选择
                                        2, 0, 2, 2, 0, tr(""), tr(""),
                                        tr("No bottom line device:0;Cylinder:1;Electromagnet:2"),//无底线装置:0;气缸:1;电磁铁:2
                                        2, 2, 0x004A, operate));

    //旋梭面对方向，范围0-3，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        30, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The hook faces the direction"),//旋梭面对方向
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Forward:0;Left:1;Right:2;Up:3"),//正:0;左:1;右:2;下:3
                                        0, 0, 0x004D, operate));

    // X框传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        50, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X box sensor coordinates"),//X框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 0, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x004F, operate));

    // Y框传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        51, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y box sensor coordinates"),//Y框传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 0, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0050, operate));

    //主轴停车传感器角度, 范围0-36000，默认4500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        52, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle parking sensor angle"),//主轴停车传感器角度
                                        4500, 0, 36000, 4500, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        4500, 4500, 0x0051, operate));

    //升降传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        53, 4, 0, PARA_VALUE_TYPE_INT,
                                        tr("Lift sensor coordinates"),//升降传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0052, operate));

    //压脚传感器坐标, 范围S32_MIN--S32_MAX, 默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        54, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Presser foot sensor coordinates"),//压脚传感器坐标
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0053, operate));

    //主轴勾线传感器角度, 范围0-36000，默认20200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        56, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle hook line sensor angle unit"),//主轴勾线传感器角度
                                        20200, 0, 36000, 20200, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        20200, 20200, 0x0055, operate));

    //冲头停车角度, 范围0-36000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        57, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punch parking angle"),//冲头停车角度
                                        0, 0, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x0056, operate));

    //主轴点动停车角度, 范围-36000-36000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        62, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle jog parking angle"),//主轴点动停车角度
                                        0, -36000, 36000, 0, 2, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        0, 0, 0x005B, operate));

    //X可移动区域负边界, 范围S32_MIN--S32_MAX, 默认6800
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        70, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X movable area negative boundary"),//X可移动区域负边界
                                        6800, S32_MIN, S32_MAX, 6800, 2, tr("mm"), tr(""),
                                        tr(""),
                                        6800, 6800, 0x005D, operate));

    //X可移动区域正边界, 范围S32_MIN--S32_MAX，默认207500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        71, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X movable area positive boundary"),//X可移动区域正边界
                                        207500, S32_MIN, S32_MAX, 207500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        207500, 207500, 0x005E, operate));

    //Y可移动区域负边界, 范围S32_MIN--S32_MAX，默认4500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        72, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y movable area negative boundary"),//Y可移动区域负边界
                                        4500, S32_MIN, S32_MAX, 4500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        4500, 4500, 0x005F, operate));

    //Y可移动区域正边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        73, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y movable area positive boundary"),//Y可移动区域正边界
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        99300, 99300, 0x0060, operate));

    //机头升降可移动上边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        74, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift can move the upper boundary"),//机头升降可移动上边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0061, operate));

    //机头升降可移动下边界, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        75, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift can move the lower boundary"),//机头升降可移动下边界
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0062, operate));

    //冲孔机头偏移X, 范围S32_MIN--S32_MAX，默认-20630
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        82, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching head offset X"),//冲孔机头偏移X
                                        -20630, S32_MIN, S32_MAX, -20630, 2, tr("mm"), tr(""),
                                        tr(""),
                                        -20630, -20630, 0x0069, operate));

    //冲孔机头偏移Y, 范围S32_MIN--S32_MAX，默认-30
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        83, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching head offset Y"),//冲孔机头偏移Y
                                        -30, S32_MIN, S32_MAX, -30, 2, tr("mm"), tr(""),
                                        tr(""),
                                        -30, -30, 0x006A, operate));

    //x可缝纫区域负边界, 范围S32_MIN--S32_MAX，默认6800
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        84, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Sewing area Negative boundary"),//x可缝纫区域负边界
                                        6800, S32_MIN, S32_MAX, 6800, 2, tr("mm"), tr(""),
                                        tr(""),
                                        6800, 6800, 0x006B, operate));

    //x可缝纫区域正边界, 范围S32_MIN--S32_MAX，默认128800
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        85, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Sewing area Positive margin"),//x可缝纫区域正边界
                                        128800, S32_MIN, S32_MAX, 128800, 2, tr("mm"), tr(""),
                                        tr(""),
                                        128800, 128800, 0x006C, operate));

    //y可缝纫区域负边界, 范围S32_MIN--S32_MAX，默认20300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        86, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Sewing area Negative boundary"),//y可缝纫区域负边界
                                        20300, S32_MIN, S32_MAX, 20300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        20300, 20300, 0x006D, operate));

    //y可缝纫区域正边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        87, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Sewing area Positive margin"),//y可缝纫区域正边界
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        99300, 99300, 0x006E, operate));

    //x可冲孔区域负边界, 范围S32_MIN--S32_MAX，默认56500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        88, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Can be perforated region Negative boundary"),//x可冲孔区域负边界
                                        56500, S32_MIN, S32_MAX, 56500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        56500, 56500, 0x006F, operate));

    //x可冲孔区域正边界, 范围S32_MIN--S32_MAX，默认178500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        89, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X Can be perforated region Positive margin"),//x可冲孔区域正边界
                                        178500, S32_MIN, S32_MAX, 178500, 2, tr("mm"), tr(""),
                                        tr(""),
                                        178500, 178500, 0x0070, operate));

    //y可冲孔区域负边界, 范围S32_MIN--S32_MAX，默认20300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        90, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Can be perforated region Negative boundary"),//y可冲孔区域负边界
                                        20300, S32_MIN, S32_MAX, 20300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        20300, 20300, 0x0071, operate));

    //y可冲孔区域正边界, 范围S32_MIN--S32_MAX，默认99300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        91, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y Can be perforated region Positive margin"),//y可冲孔区域正边界
                                        99300, S32_MIN, S32_MAX, 99300, 2, tr("mm"), tr(""),
                                        tr(""),
                                        99300, 99300, 0x0072, operate));

    //缝纫右机头偏移X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        92, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing right head offset X"),//缝纫右机头偏移X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0073, operate));

    //缝纫右机头偏移Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        93, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing right head offset Y"),//缝纫右机头偏移Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x0074, operate));

    //xy启动停止速度, 范围1-100，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        100, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY start stop speed"),//xy启动停止速度
                                        10, 1, 100, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        10, 10, 0x007B, operate));

    //xy归零运行速度, 范围1-100，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        101, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY zero running speed"),//xy归零运行速度
                                        100, 1, 100, 100, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        100, 100, 0x007C, operate));

    //xy空走运行速度, 范围1-1000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        102, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY Idling speed"),//xy空走运行速度
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        300, 300, 0x007D, operate));

    //xy行走加速度, 范围1-10000，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        103, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY walking acceleration"),//xy行走加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        1000, 1000, 0x007E, operate));

    //xy刹车加速度, 范围1-10000，默认10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        104, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY brake acceleration"),//xy刹车加速度
                                        10000, 1, 10000, 10000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        10000, 10000, 0x007F, operate));

    //xy手动移动速度1, 范围1-1000，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        105, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 1"),//xy手动移动速度1
                                        10, 1, 1000, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        10, 10, 0x0080, operate));

    //xy手动移动速度2, 范围1-1000，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        106, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 2"),//xy手动移动速度2
                                        100, 1, 1000, 100, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        100, 100, 0x0081, operate));

    //xy手动移动速度3, 范围1-1000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        107, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY manual movement speed 3"),//xy手动移动速度3
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        300, 300, 0x0082, operate));

    //xy最高移动速度, 范围1-1000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        108, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("XY maximum moving speed"),//xy最高移动速度
                                        300, 1, 1000, 300, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        300, 300, 0x0083, operate));

    //主轴启动停止转速, 范围1-300，默认100
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        109, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle start stop speed"),//主轴启动停止转速
                                        100, 1, 300, 100, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        100, 100, 0x0084, operate));

    //主轴归零转速, 范围1-3000，默认120
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle zero return speed"),//主轴归零转速
                                        120, 1, 3000, 120, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        120, 120, 0x0085, operate));

    //主轴运转转速, 范围1-3000，默认300
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        111, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle running speed"),//主轴运转转速
                                        300, 1, 3000, 300, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        300, 300, 0x0086, operate));

    //主轴运转加速度, 范围1-100，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        112, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle running acceleration"),//主轴运转加速度
                                        50, 1, 100, 50, 0, tr("r/ss"), tr(""),
                                        tr(""),
                                        50, 50, 0x0087, operate));

    //主轴刹车加速度, 范围1-100，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        113, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle brakes acceleration"),//主轴刹车加速度
                                        100, 1, 100, 100, 0, tr("r/ss"), tr(""),
                                        tr(""),
                                        100, 100, 0x0088, operate));

    //主轴缝纫最高转速, 范围1-3000，默认1200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        114, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("sewing maximum speed"),//主轴缝纫最高转速
                                        1200, 1, 3000, 1200, 0, tr("r/min"), tr(""),
                                        tr(""),
                                        1200, 1200, 0x0089, operate));

    //机头升降起停速度, 范围1-250，默认10
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        115, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift start end speed"),//机头升降起停速度
                                        10, 1, 250, 10, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        10, 10, 0x008A, operate));

    //机头升降归零速度, 范围1-250，默认50
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        116, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift and zero speed"),//机头升降归零速度
                                        50, 1, 250, 50, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        50, 50, 0x008B, operate));

    //机头升降行走速度, 范围1-250，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        117, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift walk speed"),//机头升降行走速度
                                        200, 1, 250, 200, 0, tr("mm/s"), tr(""),
                                        tr(""),
                                        200, 200, 0x008C, operate));

    //机头升降行走加速度, 范围1-10000，默认500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        118, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head lift acceleration"),//机头升降行走加速度
                                        500, 1, 10000, 500, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        500, 500, 0x008D, operate));

    //机头升降刹车加速度, 范围1-10000，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SPEED,
                                        119, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Head movements brake acceleration"),//机头升降刹车加速度
                                        1000, 1, 10000, 1000, 0, tr("mm/s2"), tr(""),
                                        tr(""),
                                        1000, 1000, 0x008E, operate));

    //主轴归零补偿角度, 范围-1000-1000，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        146, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle zero compensation angle"),//主轴归零补偿角度
                                        200, -1000, 1000, 200, 0, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        200, 200, 0x00A7, operate));

    //X轴归零补偿, 范围-1000-1000，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        147, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X compensation angle"),//X轴归零补偿
                                        200, -1000, 1000, 200, 0, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        200, 200, 0x00A8, operate));

    //Y轴归零补偿, 范围-1000-1000，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        148, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y compensation angle"),//Y轴归零补偿
                                        200, -1000, 1000, 200, 0, cod->toUnicode("°"), tr(""),
                                        tr(""),
                                        200, 200, 0x00A9, operate));

    //X间隙补偿, 范围-200-200，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X gap compensation"),//X间隙补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BC, operate));

    //Y间隙补偿, 范围-200-200，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        177, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y gap compensation"),//Y间隙补偿
                                        0, -200, 200, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BD, operate));

    //画笔偏移X, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        200, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Brush offset X"),//画笔偏移X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BE, operate));

    //画笔偏移Y, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        201, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Brush offset Y"),//画笔偏移Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""),
                                        0, 0, 0x00BF, operate));

    //进料编码器系数分子, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        204, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Encoder coefficient molecule"),//进料编码器系数分子
                                        0, S32_MIN, S32_MAX, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x00C2, operate));

    //进料编码器系数分母, 范围S32_MIN--S32_MAX，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_MACH,
                                        MC_SORT_SETTING,
                                        205, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Encoder coefficient denominator"),//进料编码器系数分母
                                        0, S32_MIN, S32_MAX, 0, 0, tr(""), tr(""),
                                        tr(""),
                                        0, 0, 0x00C3, operate));
}

//工作参数
void PunchSewMachine::initWkParasList()
{
    QTextCodec *cod = QTextCodec::codecForLocale();

    // 主轴缝纫工作转速, 范围 1--2000，单位r/min，默认1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        0, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("sewing work speed"),// 主轴缝纫工作转速
                                        1000, 1, 2000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 1000, 1000, 0x0100, operate));

    // 主轴剪线转速, 范围 1--500，单位r/min，默认120
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        1, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle Cut line speed"),// 主轴剪线转速
                                        120, 1, 500, 120, 0, tr("r/min"), tr(""),
                                        tr(""), 120, 120, 0x0101, operate));

    // 主轴回针转速, 范围 1--500，单位r/min，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        2, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle Back needle speed"),// 主轴回针转速
                                        200, 1, 500, 200, 0, tr("r/min"), tr(""),
                                        tr(""), 200, 200, 0x0102, operate));

    // 主轴启动慢动转速, 范围 1--500，单位r/min，默认 200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        3, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle start slow speed"),// 主轴启动慢动转速
                                        200, 1, 500, 200, 0, tr("r/min"), tr(""),
                                        tr(""), 200, 200, 0x0103, operate));

    // 倒车等效主轴转速, 范围 1--3000，单位r/min，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        4, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Reverse equivalent spindle speed"),// 倒车等效主轴转速
                                        1000, 1, 3000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 1000, 1000, 0x0104, operate));

    // 缝纫动框方式, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        5, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing moving frame"),// 缝纫动框方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Continuous:0;Intermittent:1"), 0, 0, 0x0105, operate));//连续:0;间歇式:1

    // 缝纫加减速方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        5, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing acceleration and deceleration mode"),// 缝纫加减速方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No acceleration or deceleration:0;Xy sine acceleration and deceleration:1"), //无加速或减速:0;Xy正弦加速度和减速度:1
                                        1, 1, 0x0106, operate));

    // 缝纫机头旋转方式, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        5, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing machine head rotating manner"),// 缝纫机头旋转方式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Continuous rotation:0;Xy intermittent rotation:1"),//连续旋转:0;Xy间歇旋转:1
                                        0, 0, 0x0107, operate));

    // 缝纫机头加减速方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        5, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing head deceleration mode"),// 缝纫机头加减速方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No acceleration or deceleration:0;Intermittent acceleration and deceleration:1"), //无加速或减速:0;间歇加减速:1
                                        1, 1, 0x0108, operate));//无加速或减速：0；间歇加减速：1

    // 缝纫动框起始角度, 范围 0--36000，默认 24000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        6, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing movable frame starting angle"),// 缝纫动框起始角度
                                        24000, 0, 36000, 24000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 24000, 24000, 0x0109, operate));

    // 缝纫动框持续角度, 范围 0--36000，默认 15000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        7, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing movable frame duration angle"),// 缝纫动框持续角度
                                        15000, 0, 36000, 15000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 15000, 15000, 0x010A, operate));

    // 起针慢动针数, 范围 0--10，默认 3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        8, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Start low speed needls"),// 起针慢动针数
                                        3, 0, 10, 3, 0, tr("Needles"), tr(""),
                                        tr(""), 3, 3, 0x010B, operate));

    // 起针动作松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        9, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle action loose line allowed"),// 起针动作松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x010C, operate));

    // 起针动作顶线允许 0, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        9, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle action top line allowed"),// 起针动作顶线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x010D, operate));

    // 起针动作夹线允许 0, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        9, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Needle action clamp line allowed"),// 起针动作夹线允许 0
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x010E, operate));

    // 绣花起针夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        9, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Allow to embroider line allowed"),// 绣花起针夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0110, operate));

    // 剪线允许, 范围 0--2，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        10, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Cut lines allow"),// 剪线允许
                                        1, 0, 2, 1, 0, tr(""), tr(""),
                                        tr("Do not trim: 0;Automatic thread trim:1;Data trim:2"),//不剪线:0;自动剪线:1;数据剪线:2
                                        1, 1, 0x0111, operate));

    // 剪线分线角度, 范围 0--36000，默认 20000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        11, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Trimming line angle"),// 剪线分线角度
                                        20000, 0, 36000, 20000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 20000, 20000, 0x0112, operate));

    // 剪线完成角度, 范围 0--36000，默认 6000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        12, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Trimming completion angle"),// 剪线完成角度
                                        6000, 0, 36000, 6000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 6000, 6000, 0x0113, operate));

    // 剪线时动作松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action loosening when thread trimming"),// 剪线时动作松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0114, operate));

    // 剪线时动作拉线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action wire pull when thread trimming"),// 剪线时动作拉线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0115, operate));

    // 剪线时动作夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action clip line allows when trimming"),// 剪线时动作夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作提升压脚允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The action of lifting the presser foot during thread cutting is allowed"),// 剪线时动作提升压脚允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作提升机头剪线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The action of lifting the machine head during thread cutting allows for thread cutting"),// 剪线时动作提升机头剪线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作提升机头夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("The action of lifting the machine head during thread cutting allows for thread clamping"),// 剪线时动作提升机头夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作在压脚下勾线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 7, 0, PARA_VALUE_TYPE_LIST,
                                        tr("When cutting the thread, the action is allowed to hook the thread under the pressure foot"),// 剪线时动作在压脚下勾线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作退针允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 8, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Allowing for needle withdrawal during thread cutting"),// 剪线时动作退针允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作勾线时松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 9, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Action during thread cutting allows for thread loosening during thread hooking"),// 剪线时动作勾线时松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));

    // 剪线时动作剪线后提升机头允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        13, 10, 0, PARA_VALUE_TYPE_LIST,
                                        tr("During thread cutting, the action is allowed to lift the machine head after thread cutting"),// 剪线时动作剪线后提升机头允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"),//不允许:0;允许:1
                                        0, 0, 0x0116, operate));


    // 断线检测针数, 范围 0--10，默认 3
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        14, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of broken wires"),// 断线检测针数
                                        3, 0, 10, 3, 0, tr("Needles"), tr(""),
                                        tr(""), 3, 3, 0x0117, operate));

    // 断线检测主轴角度, 范围 0--36000，默认 3000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        15, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Broken line detection spindle angle"),// 断线检测主轴角度
                                        3000, 0, 36000, 3000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 3000, 3000, 0x0118, operate));

    // 换梭芯提醒功能, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        16, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Change bobbin Reminder function"),// 换梭芯提醒功能
                                        0, 0, 3, 0, 0, tr(""), tr(""),  //未启用:0;按长度划分的延迟提醒:1;按切片数计数:2;按长度立即提醒:3
                                        tr("Not:0;Delay reminder by length:1;Count by number of slices:2;Immediately reminder by length:3"), 0, 0, 0x0119, operate));

    // 底线长度, 范围 0--S32_MAX，默认 10000000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        17, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Bottom line length"),// 底线长度
                                        10000000, 0, S32_MAX, 10000000, 2, tr("mm"), tr(""),
                                        tr(""), 10000000, 10000000, 0x011A, operate));

    // 每针底线修正量, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        18, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Bottom line correction per stitch"),// 每针底线修正量
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x011B, operate));

    // 换梭片数计数, 范围 0--1000，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        19, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of shuttles"),// 换梭片数计数
                                        0, 0, 1000, 0, 0, tr("times"), tr(""),
                                        tr(""), 0, 0, 0x011C, operate));

    // 加油方式选择, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        20, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Refueling method selection"),// 加油方式选择
                                        0, 0, 3, 0, 0, tr(""), tr(""),//不加油:0;按工作时间间断加油:1;按工作针数间歇加油:2;持续加油:3
                                        tr("No:0; According to working hours:1; According to the number of working stitches:2; Persistent refueling:3"), 0, 0, 0x011D, operate));

    // 加油针数间隔, 范围 S32_MIN--S32_MAX，默认 10000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        21, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling needles interval"),// 加油针数间隔
                                        10000, S32_MIN, S32_MAX, 10000, 0, tr("Needles"), tr(""),
                                        tr(""), 10000, 10000, 0x011E, operate));

    // 加油时间间隔, 范围 1--S32_MAX，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        22, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling time interval"),// 加油时间间隔
                                        1, 1, S32_MAX, 1, 0, tr("s"), tr(""),
                                        tr(""), 1, 1, 0x011F, operate));

    // 加油持续时长, 范围 1--S32_MAX，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        23, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Refueling duration"),// 加油持续时长
                                        1, 1, S32_MAX, 1, 0, tr("s"), tr(""),
                                        tr(""), 1, 1, 0x0120, operate));

    // 完成后停车位置选择, 范围 0--4，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        24, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Parking position selection after completion"),// 完成后停车位置选择
                                        0, 0, 4, 0, 0, tr(""), tr(""),
                                        tr("Current:0;Starting:1;Anchor:2;Feeding:3;Offset:4"),//当前点:0;起始点:1;定位点:2;上料点:3;偏移点:4
                                        0, 0, 0x0121, operate));

    // 偏移点坐标有效标志, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        25, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Offset point coordinate valid flag"),// 偏移点坐标有效标志
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Invalid:0;X is valid:1;Y is valid:2;XY is valid:3"),//无效:0;X有效:1;Y有效:2;XY同时有效:3
                                        0, 0, 0x0122, operate));

    // 偏移点坐标X, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        26, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Offset point coordinate X"),// 偏移点坐标X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0123, operate));

    // 偏移点坐标Y, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        27, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Offset point coordinate Y"),// 偏移点坐标Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0124, operate));

    // 穿线点坐标有效标志, 范围 0--3，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        28, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Threading point coordinate effective mark"),// 穿线点坐标有效标志
                                        0, 0, 3, 0, 0, tr(""), tr(""),
                                        tr("Invalid:0;X is valid:1;Y is valid:2;XY is valid:3"),//无效:0;X有效:1;Y有效:2;XY同时有效:3
                                        0, 0, 0x0125, operate));

    // 穿线点坐标X, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        29, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Threading point coordinates X"),// 穿线点坐标X
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0126, operate));

    // 穿线点坐标 Y, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        30, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Threading point coordinates Y"),// 穿线点坐标Y
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0127, operate));

    // 机头升降低位高度, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        31, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Machine head low position"),// 机头升降低位高度
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0128, operate));

    // 机头升降高位高度, 范围 S32_MIN--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        32, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Machine head heigh position"),// 机头升降高位高度
                                        0, S32_MIN, S32_MAX, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0129, operate));

    // 产量预设, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        33, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Production preset"),// 产量预设
                                        0, 0, S32_MAX, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x012A, operate));

    // 照明亮度, 范围 0--255，默认 128
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        34, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Illumination brightness"),// 照明亮度
                                        128, 0, 255, 128, 0, tr(""), tr(""),
                                        tr(""), 128, 128, 0x012B, operate));

    // 缝纫加速度, 范围 1--100，默认 5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        36, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing acceleration"),// 缝纫加速度
                                        5, 1, 100, 5, 0, tr("r/ss"), tr(""),
                                        tr(""), 5, 5, 0x012D, operate));

    // 剪线动框位移, 范围 1--1000，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        37, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Trimming frame displacement"),// 剪线动框位移
                                        500, 1, 1000, 500, 2, tr("mm"), tr(""),
                                        tr(""), 500, 500, 0x012E, operate));

    // 缝纫吹气允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        38, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing blow allowed"),// 缝纫吹气允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x012F, operate));

    // 冲孔吹气允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        39, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching blow allowed"),// 冲孔吹气允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0130, operate));

    // 吸尘器关闭延时, 范围 0--120，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        40, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Vacuum cleaner off delay"),// 吸尘器关闭延时
                                        0, 0, 120, 0, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x0131, operate));

    // 冲孔主轴转速, 范围 1--1200，默认 1200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        41, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle speed"),// 冲孔主轴转速
                                        1200, 1, 1200, 1200, 0, tr("r/min"), tr(""),
                                        tr(""), 1200, 1200, 0x0132, operate));

    // 冲孔加速度, 范围 1--100，默认 20
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        42, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching acceleration"),// 冲孔加速度
                                        20, 1, 100, 20, 0, tr("r/min"), tr(""),
                                        tr(""), 20, 20, 0x0133, operate));

    // 冲孔动框方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        43, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching movable frame mode"),// 冲孔动框方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("AContinuous:0;BIntermittent:1"), 0, 0, 0x0134, operate));//连续式:0;间歇式:1

    // 冲孔加减速方式, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        43, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching acceleration and deceleration mode"),// 冲孔加减速方式
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("No acceleration or deceleration:0;XY sine acceleration and deceleration:1"), 0, 0, 0x0135, operate));//无加速或减速:0;XY正弦加速度和减速度:1

    // 冲孔动框起始角度, 范围 0--36000，默认 24000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        44, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching frame starting angle"),// 冲孔动框起始角度
                                        24000, 0, 36000, 24000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 24000, 24000, 0x0136, operate));

    // 冲孔动框持续角度, 范围 0--36000，默认 15000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        45, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching frame continuous angle"),// 冲孔动框持续角度
                                        15000, 0, 36000, 15000, 2, cod->toUnicode("°"), tr(""),
                                        tr(""), 15000, 15000, 0x0137, operate));

    // 缝纫间越框机头升降, 范围 0--max，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        46, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing move head up down"),// 缝纫间越框机头升降
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0138, operate));

    // 冲孔间越框机头升降, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        47, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching move head up down"),// 冲孔间越框机头升降
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0139, operate));

    // 移框松线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        48, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Moving basket Loose line"),// 移框松线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013A, operate));

    // 移框夹线允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        48, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Moving basket Clamp line"),// 移框夹线允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013B, operate));

    // 软件限位XY移动允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit XY move allowed"),// 软件限位XY移动允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013C, operate));

    // 软件限位缝纫头升降允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit sewing head lifting allowed"),// 软件限位缝纫头升降允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013D, operate));

    // 软件限位冲孔头升降允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit punch head lifting allowed"),// 软件限位冲孔头升降允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x013E, operate));

    // 软件限位裁刀机头升降允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 4, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit cutter head lift allowed"),// 软件限位裁刀机头升降允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0140, operate));

    // 软件限位冲孔落杆限制允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit Punch drop allowed"),// 软件限位冲孔落杆限制允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0141, operate));

    // 软件限位绣花落杆限制允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        49, 6, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Software limit embroidery falling pole allowed"),// 软件限位绣花落杆限制允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0142, operate));

    // 面线勾线针数, 范围 0--5，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        52, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Number of Facial line hook"),// 面线勾线针数
                                        1, 0, 5, 1, 0, tr("Needles"), tr(""),
                                        tr(""), 1, 1, 0x0145, operate));

    // 剪线动框方向, 范围 0--4，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        57, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Trimming frame direction"),// 剪线动框方向
                                        0, 0, 4, 0, 0, tr(""), tr(""),
                                        tr("Stop:0;Left:1;Forward:2;Right:3;Backward:4"), 0, 0, 0x014A, operate));// 禁止移动:0;左:1;前:2;右:3;后:4

    // 主轴拐角转速, 范围 1--3000，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        59, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Spindle corner speed"),// 主轴拐角转速
                                        1000, 1, 3000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 1000, 1000, 0x014C, operate));

    // 降速最小偏差角度, 范围 0--180，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        60, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Minimum speed deviation angle"),// 降速最小偏差角度
                                        0, 0, 180, 0, 0, cod->toUnicode("°"), tr(""),
                                        tr(""), 0, 0, 0x014D, operate));

    // 提前降速针数, 范围 S32_MIN--S32_MAX，默认 2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        61, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Advanced dropout number"),// 提前降速针数
                                        2, S32_MIN, S32_MAX, 2, 0, tr("Needles"), tr(""),//针数
                                        tr(""), 2, 2, 0x014E, operate));

    // 延迟提速针数, 范围 S32_MIN--S32_MAX，默认 2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        62, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Delay speed number"),// 延迟提速针数
                                        2, S32_MIN, S32_MAX, 2, 0, tr("Needles"), tr(""),//针数
                                        tr(""), 2, 2, 0x014F, operate));

    // 缝纫机头工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        65, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Working permission of sewing machine head"),// 缝纫机头工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0152, operate));

    // 冲孔机头工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        65, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Work permit of punch head"),// 冲孔机头工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0153, operate));

    // 绣花机头工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        65, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Embroidery machine head work permit"),// 绣花机头工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0154, operate));

    // 开机自动找零, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        67, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Auto Zero after power on"),// 开机自动归零
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x0155, operate));

    // 换色启动方式,0,自动换色，自动启动；1，自动换色，手动启动；2，手动换色，手动启动
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        71, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Color change start method"),//换色启动方式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("Automatic color Automatic start:0;Automatic color Manual start:1;Manual color Manual start:2"),
                                        0, 0, 0x015D, operate));

    // X绣框换向补偿, 范围 -100--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        72, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X frame commutation compensation"),// X绣框换向补偿
                                        0, -100, 100, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x015E, operate));

    // Y绣框换向补偿, 范围 -100--100，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        73, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y frame commutation compensation"),// Y绣框换向补偿
                                        0, -100, 100, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x015F, operate));

    // 冲孔跳针变越框针数 ,范围0-100，单位，针，默认5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        79, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching jump stitches to change the number of stitches beyond the frame"),// 冲孔跳针变越框针数
                                        5, 0, 100, 5, 0, tr("Needles"), tr(""),
                                        tr(""), 5, 5, 0x0160, operate));

    // 冲孔点动模式, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        80, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Punching jog mode"),// 冲孔点动模式
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Lock rotate:0;rotate Lock:1"), 0, 0, 0x0161, operate));//0，先锁头，再旋转;1,先旋转，再锁头

    // 倒车工作模式, 范围 0--2，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        81, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Reverse operation mode"),// 倒车工作模式
                                        0, 0, 2, 0, 0, tr(""), tr(""),
                                        tr("normal:0;click:1;continue click:2"), 0, 0, 0x0162, operate));//0，普通模式；1，点动模式；2,持续点动模式

    // 特殊针位选择, 范围 0--9，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        82, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Special needle choose"),// 特殊针位选择
                                        0, 0, 9, 0, 0, tr(""), tr(""),
                                        tr("nothing:0;one:1;two:2;three:3;four:4;five:5;six:6;seven:7;eight:8;nine:9"), 0, 0, 0x0163, operate));//0，无；1-9，1-9针位

    // 特殊针位功能, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        83, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Special needle function"),// 特殊针位功能
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Carved hole:0;paint brush:1"), 0, 0, 0x0164, operate));//0，雕孔；1，画笔

    // 吸尘器启动延时, 范围 0--S32_MAX，单位秒,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        84, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Vacuum cleaner start delay"),// 吸尘器启动延时
                                        0, 0, S32_MAX, 0, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x0165, operate));

    // 拉料偏移值, 范围0-500000，默认90000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        89, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Drawing offset value"),// 拉料偏移值
                                        90000, 0, 500000, 90000, 0, tr(""), tr(""),
                                        tr(""), 90000, 90000, 0x0166, operate));

    // 换色速度，范围1-2000，单位mm/s,默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        99, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Color change speed"),// 换色速度
                                        200, 1, 2000, 200, 0, tr("mm/s"), tr(""),
                                        tr(""), 200, 200, 0x0167, operate));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 1, 0, PARA_VALUE_TYPE_SW,
                                        tr("first head"),//  第一个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0170, operate));

    // 工作机头选择，位图选择，共支持32个机头; 0, 不允许工作; 1, 允许工作;	bit0 第一个机头, bit1, 第二个机头......  2
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        100, 2, 0, PARA_VALUE_TYPE_SW,
                                        tr("second head"),//  第二个机头
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr(""), 0, 0, 0x0171, operate));

    // 安全输入光幕允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Secure input light curtain allows"),// 安全输入光幕允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x0169, operate));

    // 安全输入气压允许, 范围 0--1，默认 1
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 2, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Safety input pressure allowed"),// 安全输入气压允许
                                        1, 0, 1, 1, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 1, 1, 0x016A, operate));

    // 安全输入上电信号允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 3, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Safe input power-on signal allowed"),// 安全输入上电信号允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x016B, operate));

    // 安全输入安全门允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        101, 5, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Safe input emergency door allowed"),// 安全输入安全门允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x016C, operate));

    // 线迹偏移允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        104, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Stitch offset allows"),// 线迹偏移允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x016E, factory));

    // 循环工作允许, 范围 0--1，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        105, 0, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Loop work allowed"),// 循环工作允许
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Not allow:0;Allowed:1"), 0, 0, 0x016F, factory));

    // 梭加油持续时长, 范围 0--S32_MAX，默认 0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        110, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Shuttle refueling duration"),// 梭加油持续时长
                                        0, 0, S32_MAX, 0, 0, tr("s"), tr(""),
                                        tr(""), 0, 0, 0x0173, factory));

    // 中心点坐标X，范围-1000000--1000000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        142, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Center point coordinate X"),// 中心点坐标X
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0182, factory));

    // 中心点坐标Y，范围-1000000--1000000，单位0.01mm，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_POSITION,
                                        143, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Center point coordinate Y"),// 中心点坐标Y
                                        0, -1000000, 1000000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x0182, factory));


    // 针梭单传感器，0,双传感器，1，单传感器
    // bit0， 缝纫主轴
    // bit1， 绣花主轴
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        147, 1, 0, PARA_VALUE_TYPE_LIST,
                                        tr("Sewing spindle needle shuttle single sensor"),// 缝纫主轴针梭单传感器
                                        0, 0, 1, 0, 0, tr(""), tr(""),
                                        tr("Dual Sensor:0;Single sensor:1"), 0, 0, 0x0182, operate));

    // 冲孔主轴启动慢动转速, 范围 1--2000，单位r/min，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        169, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle start slow speed"),// 冲孔主轴启动慢动转速
                                        500, 1, 2000, 500, 0, tr("r/min"), tr(""),
                                        tr(""), 500, 500, 0x0182, operate));

    // 缝纫运行速度1, 范围1--5000，单位r/min，默认 500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        170, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing speed 1"),// 缝纫运行速度1
                                        500, 1, 5000, 500, 0, tr("r/min"), tr(""),
                                        tr(""), 500, 500, 0x0183, operate));

    // 缝纫运行速度2, 范围1--5000，单位r/min，默认 1000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        171, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing speed 2"),// 缝纫运行速度2
                                        1000, 1, 5000, 1000, 0, tr("r/min"), tr(""),
                                        tr(""), 1000, 1000, 0x0184, operate));

    // 缝纫运行速度3, 范围1--5000，单位r/min，默认 1500
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        172, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Sewing speed 3"),// 缝纫运行速度3
                                        1500, 1, 5000, 1500, 0, tr("r/min"), tr(""),
                                        tr(""), 1500, 1500, 0x0185, operate));

    // X工作范围, 范围 0--500000，默认 90000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        174, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("X working range"),//  X工作范围
                                        90000, 0, 500000, 90000, 2, tr("mm"), tr(""),
                                        tr(""), 90000, 90000, 0x0186, operate));

    // Y工作范围, 范围 0--5000000，默认 60000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        175, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Y working range"),// Y工作范围
                                        60000, 0, 500000, 60000, 2, tr("mm"), tr(""),
                                        tr(""), 60000, 60000, 0x0187, operate));

    // 冲孔动框最高速度，范围1-1000，单位mm/s，默认200
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        177, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Maximum speed of punching frame"),// 冲孔动框最高速度
                                        200, 1, 1000, 200, 0, tr("mm/s"), tr(""),
                                        tr(""), 200, 200, 0x0188, operate));

    // 更换冲头计数值，范围0-1000000，单位 次，默认500000
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        178, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Replace the punch count value"),// 更换冲头计数值
                                        500000, 0, 1000000, 500000, 0, tr("times"), tr(""),//次
                                        tr(""), 500000, 500000, 0x0189, operate));

    // 冲孔运针变跳针长度，范围0-2000，单位0.01mm,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        180, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Length of punching needle changing to skipping needle"),// 冲孔运针变跳针长度
                                        0, 0, 2000, 0, 2, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔吸尘器启动持续时间，范围0-100，单位s，默认5
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        181, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching vacuum cleaner start duration"),// 冲孔吸尘器启动持续时间
                                        5, 0, 100, 5, 0, tr("s"), tr(""),
                                        tr(""), 5, 5, 0x018B, operate));

    // 冲孔吸尘器启动间隔，范围0-500，单位s，默认60
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_ACTION,
                                        182, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching vacuum cleaner start interval"),// 冲孔吸尘器启动间隔
                                        60, 0, 500, 60, 0, tr("s"), tr(""),
                                        tr(""), 60, 60, 0x018C, operate));

    // 冲孔主轴归零补偿，-10000--10000，单位0.01度，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SETTING,
                                        184, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching spindle zeroing compensation"),// 冲孔主轴归零补偿
                                        0, -10000, 10000, 0, 0, cod->toUnicode("°"), tr(""),//虚拟机上识别不了,转换成可以得
                                        tr(""), 0, 0, 0x018D, operate));

    // 冲孔换色间距，范围0-10000，单位mm,默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_DETECT,
                                        186, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("Punching color change spacing"),// 冲孔换色间距
                                        0, 0, 10000, 0, 0, tr("mm"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        226, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 4-5mm"),// 冲孔运行速度限制 4-5mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        227, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 5-6mm"),// 冲孔运行速度限制 5-6mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        228, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 6-7mm"),// 冲孔运行速度限制 6-7mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        229, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 7-8mm"),// 冲孔运行速度限制 7-8mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        230, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 8-9mm"),// 冲孔运行速度限制 8-9mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        231, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 9-14mm"),// 冲孔运行速度限制 9-14mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));

    // 冲孔运行速度限制，单位r/min，范围0-3000，默认0
    m_allParasList.append(makeAParaItem(0,
                                        PARA_TYPE_WORK,
                                        MC_SORT_SPEED,
                                        232, 0, 0, PARA_VALUE_TYPE_INT,
                                        tr("speed limit 14+mm"),// 冲孔运行速度限制 14+mm
                                        0, 0, 3000, 0, 0, tr("r/min"), tr(""),
                                        tr(""), 0, 0, 0x018A, operate));
}
//电机和控制动作
void PunchSewMachine::initOutCtrlList()
{
    m_allOutCtrlList.clear();

    QString enableStr = tr("Enable");   //使能
    QString disableStr = tr("Disable"); //失能
    QString jogPStr = tr("JogP"); //正转
    QString jogNStr = tr("JogN"); //反转
    QString zeroStr = tr("Zero"); //归零
    QString openStr = tr("Open"); //打开
    QString closeStr = tr("Close");//关闭
    QString startStr = tr("Start"); //开始
    QString stopStr = tr("Stop");//停止
    QString upStr = tr("Up"); //上升
    QString downStr= tr("Down");//下降
    QString clampStr = tr("Clamp"); //夹紧
    QString relaxStr= tr("Relax");//放松
    QString outStr = tr("Out"); //伸出
    QString backStr= tr("Back");//收回

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("X to move motor"),MT_LX,// X向移动电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0002,tr("Y to move motor"),MT_LY,// Y向移动电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0003,tr("Sewing 1 needle spindle motor"),MT_LM,// 缝纫1针梭电机(主轴)        以下是lxs新加的
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Sewing 1 needle motor"),MT_LN,// 缝纫1针电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0005,tr("Sewing 1 shuttle motor"),MT_LH,// 缝纫1梭电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000B,tr("Punching 1 spindle"),MT_LPM,// 冲孔1主轴
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));\

    //等于冲缝机并为2头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_TWOHEAD)
    {
        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000C,tr("Punching 2 spindle"),MT_LP2,// 冲孔2主轴
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0013,tr("Sew spindle 2 Motor"),MT_LM2,// 缝纫2针梭电机
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x001D,tr("Sew shuttle motor 2"),MT_LH2,// 缝纫梭电机2
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x001E,tr("Sew needle motor 2"),MT_LN2,// 缝纫针电机2
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));
    }

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0027,tr("Punching color changing motor"),MT_LPS,// 冲孔换色电机
                                             enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                             disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                             jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                             jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                             zeroStr,true,OUTCONTROL_ZERO,-1,-1));

    //等于冲缝机并为2头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_TWOHEAD)
    {

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0045,tr("Punching color change motor 2"),MT_LPS2,// 冲孔换色电机2
                                                 enableStr,true,OUTCONTROL_ENABLE,-1,-1,
                                                 disableStr,true,OUTCONTROL_DISABLE,-1,-1,
                                                 jogPStr,true,-1,OUTCONTROL_JOGP,OUTCONTROL_STOP,
                                                 jogNStr,true,-1,OUTCONTROL_JOGN,OUTCONTROL_STOP,
                                                 zeroStr,true,OUTCONTROL_ZERO,-1,-1));
    }

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0004,tr("Sewing 1 cut"),OT_DCUT_THREAD,// 缝纫1下剪刀剪线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));


    //等于冲缝机并为2头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_TWOHEAD)
    {
        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0009,tr("Middle 1 foot"),OT_MID_FOOT,// 缝纫1中压脚
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 openStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 closeStr,true,OUTCONTROL_CLOSE,-1,-1));
    }

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("Head 1 elastic thread 1"),OT_LOOSE_THREAD,// 机头1松紧线1
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             relaxStr,true,OUTCONTROL_OPEN,-1,-1,
                                             clampStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0001,tr("Head 1 elastic thread 2"),OT_LOOSE_UTRD2,// 机头1松紧线2
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000A,tr("Bobbin 1 thread"),OT_PUSH_BTRD,// 缝纫1扣底线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000C,tr("Clamp 1 line"),OT_CLIP_UTRD,// 缝纫1夹面线
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             clampStr,true,OUTCONTROL_OPEN,-1,-1,
                                             relaxStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0024,tr("Hook 1 stretch"),OT_CLIP_EXTEND,// 缝纫1勾线-伸缩
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             outStr,true,OUTCONTROL_OPEN,-1,-1,
                                             backStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0026,tr("Line 1 hook"),OT_CLIP_OPEN,// 缝纫1勾线-开合
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0006,tr("Sewing 1 oiling"),OT_OIL,// 缝纫1加油
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             startStr,true,OUTCONTROL_OPEN,-1,-1,
                                             stopStr,true,OUTCONTROL_CLOSE,-1,-1));

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000E,tr("Sewing 1 head lifting"),OT_SEW_LIFT,// 缝纫1机头升降（para = 1）
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             upStr,true,MOTORHEADO_UP,-1,-1,
                                             downStr,true,MOTORHEADO_DOWN,-1,-1));

    //等于冲缝机并为2头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_TWOHEAD)
    {

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0013,tr("Scissors 2 cut"),OT_DCUT_THREAD_R,// 缝纫2下剪刀剪线
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 openStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 closeStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0015,tr("Middle 2 foot"),OT_MID_FOOT_R,// 缝纫2中压脚
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 openStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 closeStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0016,tr("Bobbin 2 thread"),OT_PUSH_BTRD_R,// 缝纫2扣底线
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 openStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 closeStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0018,tr("Clamp 2 line"),OT_CLIP_UTRD_R,// 缝纫2夹面线
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 clampStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 relaxStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0019,tr("Head 2 elastic thread 1"),OT_HEAD_R_LOOSE_THREAD,// 机头2松紧线1
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 relaxStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 clampStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0019,tr("Head 2 elastic thread 2"),OT_HEAD_R_LOOSE_UTRD2,// 机头2松紧线2
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 openStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 closeStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0025,tr("Hook 2 stretch"),OT_CLIP_EXTEND_R,// 缝纫2勾线-伸缩
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 outStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 backStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0027,tr("Line 2 hook"),OT_CLIP_OPEN_R,// 缝纫2勾线-开合
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 openStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 closeStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0028,tr("Sewing 2 oiling"),OT_OIL_R,// 缝纫2加油
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 startStr,true,OUTCONTROL_OPEN,-1,-1,
                                                 stopStr,true,OUTCONTROL_CLOSE,-1,-1));

        m_allOutCtrlList.append(makeAOutCtrlItem(0,0x000E,tr("Sewing 2 head lifting"),OT_SEW_LIFT,// 缝纫2机头升降（para = 2）
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 "",false,-1,-1,-1,
                                                 upStr,true,MOTORHEADT_UP,-1,-1,
                                                 downStr,true,MOTORHEADT_DOWN,-1,-1));

    }

    m_allOutCtrlList.append(makeAOutCtrlItem(0,0x0007,tr("Vacum cleaner"),OT_CLEANER,// 吸尘器
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             "",false,-1,-1,-1,
                                             openStr,true,OUTCONTROL_OPEN,-1,-1,
                                             closeStr,true,OUTCONTROL_CLOSE,-1,-1));
}

//快捷功能
void PunchSewMachine::initShortCutList()
{
    m_allShortCutList.clear();

    m_allShortCutList.append(makeAShortCutItem(0,0x0001,tr("All To Zero"),"buttonAllToZero",FUN_ALLTOZERO));//全部归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0002,tr("Punch Spindle Jog"),"buttonSpindleJog",FUN_PUNCHSPINDLEJOG));//冲孔主轴点动
    m_allShortCutList.append(makeAShortCutItem(0,0x0003,tr("Punch Spindle Test"),"buttonSpindleTest",FUN_SPINDLETEST));//冲孔主轴研车
    m_allShortCutList.append(makeAShortCutItem(0,0x0004,tr("Sew Spindle Test"),"buttonSpindleTest",FUN_SEWSPINDLETEST));// 缝纫主轴研车
    m_allShortCutList.append(makeAShortCutItem(0,0x0005,tr("Sew Head Up Dn"),"buttonHeadUpDn",FUN_SEWMOTORUPDOWN));//缝纫机头升降
    m_allShortCutList.append(makeAShortCutItem(0,0x0006,tr("Sew Spindle Jog"),"buttonSpindleJog",FUN_SEWSPINDLEJOG));//缝纫主轴点动
    m_allShortCutList.append(makeAShortCutItem(0,0x0007,tr("Sew Hook Position"),"buttonSewHookPosi",FUN_SEWHOOKPOSITION));//缝纫主轴去勾线位
    m_allShortCutList.append(makeAShortCutItem(0,0x0008,tr("Head 1 trim"),"buttonManualTrim",FUN_SEWHEADCUTLINEO));//机头1剪线

    //等于冲缝机并为2头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_TWOHEAD)
    {
        m_allShortCutList.append(makeAShortCutItem(0,0x0009,tr("Head 2 trim"),"buttonManualTrim1",FUN_SEWHEADCUTLINET));//机头2剪线

    }

    m_allShortCutList.append(makeAShortCutItem(0,0x000A,tr("Set Offset"),"buttonSetOffsetPoint",FUN_SETOFFSETPOINT));//定偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x000B,tr("Back Offset"),"buttonBackOffsetPoint",FUN_BACKOFFSETPOINT));//回偏移点
    m_allShortCutList.append(makeAShortCutItem(0,0x000C,tr("Sew Anchor"),"buttonSetAnchorPoint",FUN_SETANCHORPOINT));//缝纫定定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x000D,tr("Punch Anchor"),"buttonSetAnchorPoint",FUN_SECSETANCHORPOINT));//冲孔定定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x000E,tr("Back Anchor"),"buttonBackAnchorPoint",FUN_BACKANCHORPOINT));//回定位点
    m_allShortCutList.append(makeAShortCutItem(0,0x000F,tr("To Work Point"),"buttonBackWorkPoint",FUN_BACKWORKPOINT));//回工作点
    m_allShortCutList.append(makeAShortCutItem(0,0x0011,tr("Check Frame"),"buttonBorderCheck",FUN_CHECKFRAME));//边框检查
    m_allShortCutList.append(makeAShortCutItem(0,0x0012,tr("Punch Change Tool"),"buttonManualChangeColor",FUN_PUNCHMANUALCHANGECOLOR));//手动换色
    m_allShortCutList.append(makeAShortCutItem(0,0x0013,tr("Forward And Back"),"buttonForwardOrBack",FUN_FORWARDORBACK));//前进回退
    //    m_allShortCutList.append(makeAShortCutItem(0,0x0014,tr("ProcessReset"),"buttonProcessReset",FUN_PROCESSRESET));//流程复位
    m_allShortCutList.append(makeAShortCutItem(0,0x0015,tr("Needle shuttle proofread"),"buttonNeedleTest",FUN_NEEDLECONTRAST));//针梭校对
    m_allShortCutList.append(makeAShortCutItem(0,0x0016,tr("Single Punch"),"buttonSinglePunch",FUN_SINGLEPUNCH));//单次冲孔
    //    m_allShortCutList.append(makeAShortCutItem(0,0x0017,tr("FrameZero"),"buttonFrameZero",FUN_FRAMEZERO));//框架归零
    m_allShortCutList.append(makeAShortCutItem(0,0x0018,tr("To Right Up"),"buttonMoveToRightUp",FUN_MOVETORIGHTUP));//去右上角
    m_allShortCutList.append(makeAShortCutItem(0,0x0019,tr("To Right Down"),"buttonMoveToRightDown",FUN_MOVETORIGHTDOWN));//去右下角
    m_allShortCutList.append(makeAShortCutItem(0,0x001A,tr("To Left Up"),"buttonMoveToLeftUp",FUN_MOVETOLEFTUP));//去左上角
    m_allShortCutList.append(makeAShortCutItem(0,0x001B,tr("To Left Down"),"buttonMoveToLeftDown",FUN_MOVETOLEFTDOWN));//去左下角
    m_allShortCutList.append(makeAShortCutItem(0,0x001C,tr("Scope Work"),"buttonSetWorkRange",FUN_SETWORKRANGE));//定工作范围
    m_allShortCutList.append(makeAShortCutItem(0,0x001D,tr("Punch Stop Lower"),"buttonPunchStopLower",FUN_PUNCHSTOPLOWER));//冲头停下位
    m_allShortCutList.append(makeAShortCutItem(0,0x001E,tr("Switch Sew Head"),"buttonSewHead",FUN_SELECTSEWHEAD));//切换缝纫机头
    m_allShortCutList.append(makeAShortCutItem(0,0x001F,tr("Switch Punch Head"),"buttonPunchHead",FUN_SELECTPUCNHHEAD));//切换冲孔机头
    m_allShortCutList.append(makeAShortCutItem(0,0x0020,tr("To Center point"),"buttonToCenterDot",FUN_RETURNTOCENTERPOINT));//回中心点
}

//辅助功能
void PunchSewMachine::initAssistList()
{
    m_allAssistList.clear();

    m_allAssistList.append(makeAAssistItem(0,0x0001,tr("SensorSign"),"buttonSensor",ASSIST_SENSOR));//传感器信号
    m_allAssistList.append(makeAAssistItem(0,0x0002,tr("Action"),"buttonControlAction",ASSIST_CONTROLACTION));//控制动作
    m_allAssistList.append(makeAAssistItem(0,0x0003,tr("HMIUpgrade"),"buttonHMIUpgrade",ASSIST_HMIUPGRADE));//界面升级
    m_allAssistList.append(makeAAssistItem(0,0x0004,tr("MCUpgrade"),"buttonMCUpgrade",ASSIST_MCUPGRADE));//主控升级
    m_allAssistList.append(makeAAssistItem(0,0x0006,tr("ParaImport"),"buttonParaImport",ASSIST_PARAIMPORT));//参数导入
    m_allAssistList.append(makeAAssistItem(0,0x0007,tr("ParaExport"),"buttonParaExport",ASSIST_PARAEXPORT));//参数导出
    m_allAssistList.append(makeAAssistItem(0,0x0008,tr("SoftwareSet"),"buttonSoftwareSet",ASSIST_SOFTWARESET));//软件设置
    m_allAssistList.append(makeAAssistItem(0,0x0009,tr("SoftPower"),"buttonSoftwareAuthor",ASSIST_AUTHORIZATION));//软件授权
    m_allAssistList.append(makeAAssistItem(0,0x000A,tr("Network"),"buttonNetworkManage",ASSIST_NETWORK));//网络管理
    s16 wifi = g_pSettings->readFromIniFile("HMI/wifi").toInt();//是否有wifi
    if(wifi == 1)
    {
        m_allAssistList.append(makeAAssistItem(0,0x000A,tr("WIFI"),"buttonWIFI",ASSIST_WIFI));//WIFI管理
    }
    m_allAssistList.append(makeAAssistItem(0,0x000B,tr("NeedleSet"),"buttonNeedleSet",ASSIST_NEEDLESET));//针杆设置
    m_allAssistList.append(makeAAssistItem(0,0x000C,tr("TimeSet"),"buttonTimeSet",ASSIST_TIMESET));//时间设置
    m_allAssistList.append(makeAAssistItem(0,0x000D,tr("ShortcutSet"),"buttonCommonFunction",ASSIST_SHORTCUTSET));//常用设置
    m_allAssistList.append(makeAAssistItem(0,0x000E,tr("Productnum"),"buttonProductStatistics",ASSIST_PRODUCTSTATICS));//生产统计
    m_allAssistList.append(makeAAssistItem(0,0x000F,tr("Version"),"buttonVersionInfo",ASSIST_MCVERSION));//版本信息
    m_allAssistList.append(makeAAssistItem(0,0x0010,tr("CountReset"),"buttonBottomCountReset",ASSIST_BOTTOMLINECOUNTRESET));//底线计数复位
    m_allAssistList.append(makeAAssistItem(0,0x0014,tr("Root"),"buttonRoot",ASSIST_ROOT));//超级用户
}

//花样设置
void PunchSewMachine::initPatternSetList()
{
    m_allPatternSetList.clear();

    m_allPatternSetList.append(makeAPatternSetItem(0,0x0001,tr("Select"),"buttonPatternSelect",PATTERNSET_PATTERNSELECT));//花样选择
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0002,tr("Para"),"buttonPatternPara",PATTERNSET_PATTERNPARA));//花样参数
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0003,tr("Color"),"buttonPatternColorOrder",PATTERNSET_PATTERNCOLOR));//花样色序
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0004,tr("Import"),"buttonPatternImport",PATTERNSET_PATTERNIMPORT));//花样导入
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0005,tr("Export"),"buttonPatternExport",PATTERNSET_PATTERNEXPORT));//花样导出
    m_allPatternSetList.append(makeAPatternSetItem(0,0x0006,tr("Delete"),"buttonPatternDelete",PATTERNSET_PATTERNDELETE));//花样删除
}

//参数分类(参数分组功能)
void PunchSewMachine::initParaSetList()
{
    m_allParaSetList.clear();

    m_allParaSetList.append(makeAParaSetItem(0,0x0001,tr("OperatPara"),"buttonOperatParas",PARASET_SETTING));//设置参数  //操作参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0002,tr("ActionSet"),"buttonActionParas",PARASET_ACTION));//动作参数   //动作设定
    m_allParaSetList.append(makeAParaSetItem(0,0x0003,tr("SpeedPara"),"buttonSpeedParas",PARASET_SPEED));//速度参数  //速度控制参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0004,tr("LimitPara"),"buttonPositionParas",PARASET_POSITION));// 位置参数  //限位参数
    m_allParaSetList.append(makeAParaSetItem(0,0x0005,tr("MCPara"),"buttonSettingParas",PARASET_DETECT));//检测参数    //机器参数
}

//初始化传感器列表
void PunchSewMachine::initSensorList()
{
    QList <SensorItem> sensorList;

    sensorList.append(makeASensorItem(0x0000, 0, tr("Start button 1")));//启动按钮1
    sensorList.append(makeASensorItem(0x0001, 0, tr("Pause button 1")));//暂停按钮1
    sensorList.append(makeASensorItem(0x0002, 0, tr("Jog button 1")));//点动按钮1
    sensorList.append(makeASensorItem(0x0007, 0, tr("Air pressure protection input")));//气压保护输入
    sensorList.append(makeASensorItem(0x0020, 0, tr("X zero position")));//X零位
    sensorList.append(makeASensorItem(0x0020, 1, tr("Y zero position")));//Y零位
    sensorList.append(makeASensorItem(0x0021, 0, tr("X deceleration")));//X降速
    sensorList.append(makeASensorItem(0x0021, 1, tr("Y deceleration")));//Y降速
    sensorList.append(makeASensorItem(0x0022, 0, tr("X negative limit")));//X负限位
    sensorList.append(makeASensorItem(0x0022, 1, tr("Y negative limit")));//Y负限位
    sensorList.append(makeASensorItem(0x0023, 0, tr("X positive limit")));//X正限位
    sensorList.append(makeASensorItem(0x0023, 1, tr("Y positive limit")));//Y正限位

    sensorList.append(makeASensorItem(0x0040, 0, tr("Sewing machine head 1 lifting upper limit")));//缝纫机头1升降上限位
    sensorList.append(makeASensorItem(0x0042, 0, tr("Lower lifting limit of sewing machine head 1")));//缝纫机头1升降下限位
    sensorList.append(makeASensorItem(0x0080, 0, tr("Sewing spindle 1 needle - parking space")));//缝纫主轴1针-停车位
    sensorList.append(makeASensorItem(0x0082, 0, tr("Sewing spindle 1 needle - thread hooking position")));//缝纫主轴1针-勾线位
    sensorList.append(makeASensorItem(0x0088, 0, tr("Sewing shuttle 1- parking space")));//缝纫旋梭1-停车位
    sensorList.append(makeASensorItem(0x008A, 0, tr("Sewing rotary hook 1-thread hook position")));//缝纫旋梭1-勾线位

    sensorList.append(makeASensorItem(0x0090, 0, tr("Punching spindle 1 zero position")));//冲孔主轴1零位
    sensorList.append(makeASensorItem(0x00A0, 0, tr("Punching spindle 1 position detection")));//冲孔主轴1位置检测
    sensorList.append(makeASensorItem(0x002C, 0, tr("Punching 1 color change motor - zero position")));//冲孔1换色电机-零位
    sensorList.append(makeASensorItem(0x002E, 0, tr("Punching 1 color change motor - negative limit")));//冲孔1换色电机-负限位
    sensorList.append(makeASensorItem(0x002F, 0, tr("Punching 1 color change motor - positive limit")));//冲孔1换色电机-正限位

    sensorList.append(makeASensorItem(0x0170, 0, tr("Sewing 1 thread breakage detection")));//缝纫1断线检测
    sensorList.append(makeASensorItem(0x0174, 0, tr("Sewing 1 scissors return")));//缝纫1下剪刀回位

    //等于冲缝机并为1头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_SINGLEHEAD)
    {
        sensorList.append(makeASensorItem(0x0008, 0, tr("Safety input")));// 安全输入
    }

    //等于冲缝机并为2头
    if(g_emMacType == MACHINE_PUNCH_SEW && g_emProductType == PRODUCT_PUNCHSEW_TWOHEAD)
    {
        sensorList.append(makeASensorItem(0x002C, 1, tr("Punching 2 color change motor - zero position")));//冲孔2换色电机-零位
        sensorList.append(makeASensorItem(0x002E, 1, tr("Punching 2 color change motor - negative limit")));//冲孔2换色电机-负限位
        sensorList.append(makeASensorItem(0x002F, 1, tr("Punching 2 color change motor - positive limit")));//冲孔2换色电机-正限位
        sensorList.append(makeASensorItem(0x0040, 1, tr("Sewing machine head 2 lifting upper limit")));//缝纫机头2升降上限位
        sensorList.append(makeASensorItem(0x0042, 1, tr("Lower lifting limit of sewing machine head 2")));//缝纫机头2升降下限位
        sensorList.append(makeASensorItem(0x0080, 1, tr("Sewing spindle 2 needle - parking space")));//缝纫主轴2针-停车位
        sensorList.append(makeASensorItem(0x0082, 1, tr("Sewing spindle 2 needle - thread hooking position")));//缝纫主轴2针-勾线位
        sensorList.append(makeASensorItem(0x0088, 1, tr("Sewing shuttle 2- parking space")));//缝纫旋梭2-停车位
        sensorList.append(makeASensorItem(0x008A, 1, tr("Sewing rotary hook 2-thread hook position")));//缝纫旋梭2-勾线位
        sensorList.append(makeASensorItem(0x0090, 1, tr("Punching spindle 2 zero position")));//冲孔主轴2零位
        sensorList.append(makeASensorItem(0x00A0, 1, tr("Punching spindle 2 position detection")));//冲孔主轴2位置检测
        sensorList.append(makeASensorItem(0x0170, 1, tr("Sewing 2 thread breakage detection")));//缝纫2断线检测
        sensorList.append(makeASensorItem(0x0174, 1, tr("Sewing 2 scissors return")));//缝纫2下剪刀回位
    }

    //将机型所需的传感器列表替换到传感器整体列表中
    for(int i = 0; i < sensorList.size(); i++)
    {
        int byteaddr = sensorList[i].m_byte_offset;
        int bitaddr = sensorList[i].m_bit_offset;
        QString str = sensorList[i].m_name;
        int type = sensorList[i].m_type;

        int idx = byteaddr*8+bitaddr;
        if(idx < m_allSensorList.size())
        {
            m_allSensorList[idx].m_name = str;
            m_allSensorList[idx].m_type = type;
        }
    }
}

//初始化错误代码和状态列表
void PunchSewMachine::initErrorCodeAndStateList()
{
    m_allErrorCodeAndStateList.clear();

    //错误代码
    m_allErrorCodeAndStateList.append(makeAErrorStateItem(ERR_SPT_NCE, tr("Small platen not closed")));// 小台板未关闭
}

