#ifndef LOTSETTINGS_H
#define LOTSETTINGS_H

//物联网数据key
//上行数据属性列表
#define U00001 "progress"                          //完成进度(%) int
#define U00002 "products"                          //生产数量 int
#define U00003 "Action"                              //动作(0:开始;1:停止;9:剪线) int
#define U00004 "Turns"                               //转速 int
#define U00005 "xInitCoordinate"                 //定位点x int
#define U00006 "ynitCoordinate"                  //定位点y int
#define U00007 "xCoordinate"                     //当前点位x int
#define U00008 "yCoordinate"                     //当前点位y int
#define U00009 "realTime"                          //一天机器实际工作时间时间戳 int
#define U00010 "estimatedTime"                 //标准时间完成一件产品时间时间戳 int
#define U00011 "totalWork"                        //工作总量 int
#define U00012 "totalTime"                        //一天生产总时间时间戳 int
#define U00013 "machineTime"                   //一天机器做工工作时间时间戳 int
#define U00014 "TotalNeedle"                     //累计针数 int
#define U00015 "totalTime"                        //累计刺绣时间 int
#define U00016 "machineName"                 //机器(设备)名称 string
#define U00017 "deviceID"                         //设备(机器)ID string
#define U00018 "RackNumber"                    //机器编号(机架号) int
#define U00019	"Oline"	                            //是否在线(0:离线;1:在线) int
#define U00020	"ErrorCode"	                    //错误编码 int
#define U00021	"Message"	                        //提示信息 string
#define U00022 "MachineEdition"                 //机器版本 string
#define U00023 "AlarmInformation"              //报警信息 string
#define U00024 "TotalAuthorizationTime"       //授权总时间(min) int
#define U00025 "AuthorizationTimeRemaining"//授权剩余时间(min) int
#define U00026 "StartupTime"                      //开机时间(min) int
#define U00027 "RunningTime"                     //运行时间(min) int
#define U00028 "CurrentProduction"              //当前产量 int
#define U00029 "OutputSetting"                    //产量设定 int
#define U00030 "InterfaceVersion"                 //界面版本 string
#define U00031 "StagesPasswordState"          //分期密码状态(0:未设置;1:已设置) int
#define U00032	"RemoteUpgradeState"         //是否远程升级(0,1) int
#define U00033	"DeviceStatus"                     //设备状态编码 int
#define U00034	"spindleZeroSta"                          //主轴零位状态 int
#define U00035	"SpindleAngle"                     //主轴角度 int
#define U00036	"Frame_X"                           //绣框X坐标 int
#define U00037	"Frame_Y"                           //绣框y坐标 int
#define U00038	"StartButton1"                    //启动按钮1(0,1) int
#define U00039	"PauseButton1"                   //暂停按钮1(0,1) int
#define U00040	"JogButton1"                      //点动按钮1(0,1) int
#define U00041	"MFrameX_Z"                      //主框架X零位 int
#define U00042	"MFrameY_Z"                      //主框架Y零位 int
#define U00043	"MFrameX_N"                      //主框架X负限位 int
#define U00044	"MFrameY_N"                      //主框架Y负限位 int
#define U00045	"MFrameX_P"                      //主框架X正限位 int
#define U00046	"MFrameY_P"                      //主框架Y正限位 int
#define U00047	"ScissorsReturn"                 //剪刀回位(0,1) int

//0	断电(离线)
//1	上电(在线)
//2	开始工作(工作)
//3	结束工作(待机)
//WorkingState=0/1/2时，StartTime、EndTime均可不传
#define U00048	"WorkingState"                 //工作状态
#define U00049	"StartTime"                        //开始时间
#define U00050	"EndTime"                         //结束时间
#define U00051	"Pins"                                //区间针数
#define U00052	"CurrentProduction"         //当前产量 int

#define U000102 "electric_total"                  //电机总数 int
#define U000103 "sensor_total"                   //传感器总数 int
#define U000118  "realityTime"                    //手动输入实际交付时间   string
#define U000119 "manualProgress"           //手动输入安装/调试进度   int
#define U000120 "hookMode"	                 //勾线模式
#define U000121 "taperedMode"	               //锁头模式
#define U000122 "sewHeadNumbers"             	//缝纫机头个数
#define U000123 "embHeadNumbers"	            //绣花机头个数
#define U000124 "embneedleNumbers"	         //绣花机针个数
#define U000125 "punchHeadNumbers"      	//冲孔机头个数
#define U000126 "punchneedleNumbers"	   //冲孔机针个数
#define U000149 "WorkProgress"	   //机器工作进度


#define S0504	0                 //断电(离线)
#define S0505	1                 //上电(在线)
#define S0506	2                 //开始工作(工作)
#define S0507	3                 //结束工作(待机)

//下行数据属性列表
#define D00001	"StagesPassword	"               //分期密码 string
#define D00002	"Start"                               //开机指令(0,1) bool
#define D00003	"Stop"                               //停止指令(0,1) bool
#define D00004	"SetTurns"                         //设置转速 int
#define D00005	"RemoteUpgrade"               //远程升级(0,1) bool
//传感器信号索引，对应的excel表
#define S00000	"S00000"                 //启动按钮
#define S00010	"S00010"                 //暂停按钮
#define S00020	"S00020"                 //点动按钮
#define S00070	"S00070"                 //气压检测
#define S00200	"S00200"                 //主框架X零位
#define S00201	"S00201"                 //主框架Y零位
#define S00220	"S00220"                 //主框架X负限位
#define S00221	"S00221"                 //主框架Y负限位
#define S00230	"S00230"                 //主框架X正限位
#define S00231	"S00231"                 //主框架Y正限位
#define S01000	"S01000"                 //剪刀回位
#endif // LOTSETTINGS_H
